//+------------------------------------------------------------------+
//|                                                  CCI Woodie like |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  Black //DarkSlateGray
#property indicator_color2  Black //Blue
#property indicator_color3  Black //Red
#property indicator_color4  Black //Yellow
#property indicator_color5  Green //LimeGreen
#property indicator_color6  Red //Tomato
#property indicator_color7  Black //DimGray
#property indicator_color8  Black //YellowGreen
#property indicator_width1  0
#property indicator_width2  0
#property indicator_width3  0
#property indicator_width4  0 
#property indicator_width5  3 //4 //2
#property indicator_width6  3 //4 //2
#property indicator_width7  0

//
//
//
//
//


#property indicator_levelcolor Black

//
//
//
//
//

extern string TimeFrame            = "Current time frame";
extern int    CCIPeriod            = 20;
extern int    TrendPeriod          =  6;
extern int    TurboCCIPeriod       =  6;
extern int    LSMAPeriod           = 25;
extern int    LSMAPrice            = PRICE_CLOSE;


extern bool   ShowLastValueBoxes   = True;
extern int    DisplayBoxCount      = 5;

string TAG = "PM_CCI_Woodie"   ;
//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];
double buffer8[];
string IndicatorFileName;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   deinit();
   SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_HISTOGRAM); //DRAW_HISTOGRAM
   SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_NONE); //DRAW_HISTOGRAM
   SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_NONE); //DRAW_HISTOGRAM
   SetIndexBuffer(3,buffer4); SetIndexStyle(3,DRAW_NONE); //DRAW_HISTOGRAM
   SetIndexBuffer(4,buffer5); SetIndexStyle(4,DRAW_ARROW);  SetIndexArrow(4,167);
   SetIndexBuffer(5,buffer6); SetIndexStyle(5,DRAW_ARROW);  SetIndexArrow(5,167);
   SetIndexBuffer(6,buffer7); SetIndexStyle(6,DRAW_NONE);
   SetIndexBuffer(7,buffer8); SetIndexStyle(7,DRAW_NONE);

   //
   //
   //
   //
   //
   
   timeFrame = stringToTimeFrame(TimeFrame);
      if (timeFrame < Period()) timeFrame = Period();
      
   //
   //
   //
   //
   //
   IndicatorShortName("CCI PM ("+CCIPeriod+","+TurboCCIPeriod+")[TF"+ timeFrame+"]");         
   IndicatorFileName = WindowExpertName();
   return(0);
}
int deinit()
{
   ObDeleteObjectsByPrefix(TAG);  
   return(0);
}


void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   int    i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;


   //
   //
   //
   //
   //

      if (timeFrame != Period())
      {
         limit = MathMax(limit,timeFrame/Period());
         
         //
         //
         //
         //
         //
         
         for(i=limit; i>=0; i--)
         {
            int y = iBarShift(NULL,timeFrame,Time[i]);
                  buffer1[i] = iCustom(NULL,timeFrame,IndicatorFileName,"",CCIPeriod,TrendPeriod,TurboCCIPeriod,LSMAPeriod,LSMAPrice,0,y);
                  buffer2[i] = iCustom(NULL,timeFrame,IndicatorFileName,"",CCIPeriod,TrendPeriod,TurboCCIPeriod,LSMAPeriod,LSMAPrice,1,y);
                  buffer3[i] = iCustom(NULL,timeFrame,IndicatorFileName,"",CCIPeriod,TrendPeriod,TurboCCIPeriod,LSMAPeriod,LSMAPrice,2,y);
                  buffer4[i] = iCustom(NULL,timeFrame,IndicatorFileName,"",CCIPeriod,TrendPeriod,TurboCCIPeriod,LSMAPeriod,LSMAPrice,3,y);
                  buffer5[i] = iCustom(NULL,timeFrame,IndicatorFileName,"",CCIPeriod,TrendPeriod,TurboCCIPeriod,LSMAPeriod,LSMAPrice,4,y);
                  buffer6[i] = iCustom(NULL,timeFrame,IndicatorFileName,"",CCIPeriod,TrendPeriod,TurboCCIPeriod,LSMAPeriod,LSMAPrice,5,y);
                  buffer7[i] = iCustom(NULL,timeFrame,IndicatorFileName,"",CCIPeriod,TrendPeriod,TurboCCIPeriod,LSMAPeriod,LSMAPrice,6,y);
                  buffer8[i] = iCustom(NULL,timeFrame,IndicatorFileName,"",CCIPeriod,TrendPeriod,TurboCCIPeriod,LSMAPeriod,LSMAPrice,7,y);
         }

         return(0);         
      }

   //
   //
   //
   //
   //
   
   for (i=limit;i>=0;i--)
   {
       if (TurboCCIPeriod>1) buffer8[i] = iCCI(NULL,0,TurboCCIPeriod,PRICE_TYPICAL,i); 
                             buffer7[i] = iCCI(NULL,0,CCIPeriod     ,PRICE_TYPICAL,i);
                             buffer1[i] = buffer7[i];
            SetHisto(i);
            SetLsma(i);
 
  }
   
   
   
   // temp
color colorBuf5, colorBuf6;
colorBuf5=Red;
colorBuf6=Red;

      if (buffer5[0]==EMPTY_VALUE) colorBuf5=Green;
      if (buffer6[0]==EMPTY_VALUE) colorBuf6=Green;
      
  //     setObject("Buf5", "Buffer 5  " + DoubleToStr(buffer5[0],2) ,30,300,colorBuf5); 
//      setObject("Buf6", "Buffer 6  " + DoubleToStr(buffer6[0],2) ,30,315,colorBuf6); 

   // Als buffer[5]=EMPTY_VALUE AND buffer[6]=0.00 =>> SHORT (CCI is ROOD)
   // Als buffer[6]=EMPTY_VALUE AND buffer[5]=0.00 =>> LONG (CCI is GROEN)


// HA color
//   setItemLabel(dLabel09, StrX09, Xdist_text, Ydist_X09,WindowToUse,Corner_text,LabelColor);
//   setItemValue(dValue09, " " +CharToStr(110)+CharToStr(110)+CharToStr(110)+CharToStr(110) ,Xdist_vSRFP,Ydist_X09,WindowToUse,Corner_vSRFP,color_X09, "Wingdings",12);


   
   if (ShowLastValueBoxes)
   {
      int intI;
      for (intI=0;intI<=DisplayBoxCount-1;intI++)
      {
         //TODO: Laatste 3 bars displayen wat de kleur was
         if(buffer5[intI]==EMPTY_VALUE && buffer6[intI]==0.00)
         setObject(TAG + "BoxGauge"+DoubleToStr(intI,0), CharToStr(110) ,15+ (intI*12),12,Red,"Wingdings",12); 
         else if(buffer6[intI]==EMPTY_VALUE && buffer5[intI]==0.00)
         setObject(TAG + "BoxGauge"+DoubleToStr(intI,0), CharToStr(110) ,15+ (intI*12),12,Green,"Wingdings",12); 

         setObject(TAG + "BoxGaugeH"+DoubleToStr(intI,0), DoubleToStr(intI,0) ,18+ (intI*12),0,DodgerBlue); //,"Arial",8); 

      }      
         setObject(TAG + "BoxGaugeLabel", "Last N-CCI" ,15+ (intI*12)+20,12,DodgerBlue); 

   }
/*
      //TODO: Laatste 3 bars displayen wat de kleur was
      if(buffer5[0]==EMPTY_VALUE && buffer6[0]==0.00)
       setObject("PM_CCIN", CharToStr(110) ,30,0,Red,"Wingdings",12); 
      else if(buffer6[0]==EMPTY_VALUE && buffer5[0]==0.00)
       setObject("PM_CCIN", CharToStr(110) ,30,0,Lime,"Wingdings",12); 
      
      // n-1
      if(buffer5[1]==EMPTY_VALUE && buffer6[1]==0.00)
       setObject("PM_CCIN1", CharToStr(110) ,45,0,Red,"Wingdings",12); 
      else if(buffer6[1]==EMPTY_VALUE && buffer5[1]==0.00)
       setObject("PM_CCIN1", CharToStr(110) ,45,0,Lime,"Wingdings",12); 
*/

/*
      if(buffer5[0]==EMPTY_VALUE && buffer6[0]==0.00)
       setObject("BufStatus", "CCI is rood" ,30,0,Red); 
      else if(buffer6[0]==EMPTY_VALUE && buffer5[0]==0.00)
       setObject("BufStatus", "CCI is groen" ,30,0,Lime); 
*/


      
//      buffer1[0]=limit;
/*      
      setObject("pmcci5", "b[5]=" + DoubleToStr(buffer5[0],2) ,30,15,DodgerBlue); 
       setObject("pmcci6", "b[6]=" + DoubleToStr(buffer6[0],2) ,30,30,DodgerBlue); 

       setObject("pmcci1", "[1]=" + DoubleToStr(buffer1[0],2) ,30,45,DodgerBlue); 
       setObject("pmcci2", "[2]=" + DoubleToStr(buffer2[0],2) ,30,60,DodgerBlue); 
       setObject("pmcci3", "[3]=" + DoubleToStr(buffer3[0],2) ,30,75,DodgerBlue); 
       setObject("pmcci4", "[4]=" + DoubleToStr(buffer4[0],2) ,30,90,DodgerBlue); 
       setObject("pmcci7", "[7]=" + DoubleToStr(buffer7[0],2) ,30,105,DodgerBlue); 
*/   
   // Als buffer[5]=0.00 and buffer6 is EMPTY_VALUE dan groen (long)
   // Als buffer[6]=0.00 and buffer5 is EMPTY_VALUE dan rood (short)
   
   return(0);
}

void setObject(string labelName,string text,int x,int y,color theColor, string font = "Courier New",int size=10,int angle=0)
{
 
      
      if (ObjectFind(labelName) == -1)
          {
             ObjectCreate(labelName,OBJ_LABEL,1,0,0);
             ObjectSet(labelName,OBJPROP_CORNER,1);
             if (angle != 0)
                  ObjectSet(labelName,OBJPROP_ANGLE,angle);
          }               
       ObjectSet(labelName,OBJPROP_XDISTANCE,x);
       ObjectSet(labelName,OBJPROP_YDISTANCE,y);
       ObjectSetText(labelName,text,size,font,theColor);
}

  
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void SetHisto(int i)
{
   int k,s;

   buffer2[i] = EMPTY_VALUE;
   buffer3[i] = EMPTY_VALUE;
   buffer4[i] = EMPTY_VALUE;
   
   //
   //
   //
   //
   //

      if (buffer7[i]>0)
         if (buffer2[i+1] != EMPTY_VALUE) s = TrendPeriod;
         else
            for (k=1,s= 1; k<TrendPeriod; k++,s++) if (buffer3[i+k] != EMPTY_VALUE) break;

      if (buffer7[i]<0)
         if (buffer3[i+1] != EMPTY_VALUE) s = -TrendPeriod;
         else
            for (k=1,s=-1; k<TrendPeriod; k++,s--) if (buffer2[i+k] != EMPTY_VALUE) break;

      if (s ==  TrendPeriod) buffer2[i] = buffer7[i];
      if (s == -TrendPeriod) buffer3[i] = buffer7[i];
   
   //
   //
   //
   //
   //
   
   if (MathAbs(s) == (TrendPeriod-1)) buffer4[i] = buffer7[i];
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void SetLsma(int i)
{
   double ma1=iMA(NULL,0,LSMAPeriod,0,MODE_SMA ,LSMAPrice,i);
   double ma2=iMA(NULL,0,LSMAPeriod,0,MODE_LWMA,LSMAPrice,i);
   double lsmaValue = 3.0*ma2-2.0*ma1;
   
   buffer5[i] = EMPTY_VALUE;
   buffer6[i] = EMPTY_VALUE;
      if (Close[i] > lsmaValue) buffer5[i] =  0.00;
      if (Close[i] < lsmaValue) buffer6[i] =  0.00;
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   for(int l = StringLen(tfs)-1; l >= 0; l--)
   {
      int char = StringGetChar(tfs,l);
          if((char > 96 && char < 123) || (char > 223 && char < 256))
               tfs = StringSetChar(tfs, l, char - 32);
          else 
              if(char > -33 && char < 0)
                  tfs = StringSetChar(tfs, l, char + 224);
   }

   //
   //
   //
   //
   //
   
   int tf=Period();
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
   return(tf);
}

//
//
//
//
//
//

/*
string TimeFrameToString(int tf)
{
   string tfs="Current time frame";
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}
*/